package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TipoInformativoComissaoDAO;
import com.rjconsultores.ventaboletos.entidad.TipoInformativoComissao;

@Repository("tipoInformativoComissaoDAO")
public class TipoInformativoComissaoHibernateDAO extends GenericHibernateDAO<TipoInformativoComissao, Integer>
		implements TipoInformativoComissaoDAO {

	@Autowired
	public TipoInformativoComissaoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<TipoInformativoComissao> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public Boolean existeTipoInformativo(TipoInformativoComissao tipo) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("desctipo", tipo.getDesctipo()));
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		if (tipo.getTipoinformativoId() != null) {
			c.add(Restrictions.ne("tipoinformativoId", tipo.getTipoinformativoId()));
		}

		return c.list().isEmpty();
	}
}
